# envd fish shell completion

function __fish_envd_no_subcommand --description 'Test if there has been any subcommand yet'
    for i in (commandline -opc)
        if contains -- $i bootstrap run c completion help h context create ls rm use build b destroy down d envs env e describe d list ls l images image describe d list ls l prune remove r rm init i login pause p prune exec resume r up u debug b llb b version v top reference
            return 1
        end
    end
    return 0
end

complete -c envd -n '__fish_envd_no_subcommand' -f -l debug -d 'enable debug output in logs'
complete -c envd -n '__fish_envd_no_subcommand' -f -l analytics-enabled -d 'enable analytics'
complete -c envd -n '__fish_envd_no_subcommand' -f -l help -s h -d 'show help'
complete -c envd -n '__fish_envd_no_subcommand' -f -l help -s h -d 'show help'
complete -c envd -n '__fish_seen_subcommand_from bootstrap' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'bootstrap' -d 'Bootstrap the envd installation'
complete -c envd -n '__fish_seen_subcommand_from bootstrap' -f -l buildkit -s b -d 'Download the image and bootstrap buildkit'
complete -c envd -n '__fish_seen_subcommand_from bootstrap' -f -l with-autocomplete -d 'Add envd auto-completions'
complete -c envd -n '__fish_seen_subcommand_from bootstrap' -f -l dockerhub-mirror -s m -r -d 'DockerHub mirror to use'
complete -c envd -n '__fish_seen_subcommand_from bootstrap' -f -l registry-ca-keypair -s ca -r -d 'Specify the ca/key/cert file path for the private registry (format: \'ca=/etc/config/ca.pem,key=/etc/config/key.pem,cert=/etc/config/cert.pem\')'
complete -c envd -n '__fish_seen_subcommand_from bootstrap' -f -l ssh-keypair -s k -r -d 'Manually specify ssh key pair as `publicKey,privateKey`. envd will generate a keypair at /private/tmp/envd-20240124-3530-8po7f2/envd-0.3.45/.brew_home/.config/envd/id_rsa_envd.pub and /private/tmp/envd-20240124-3530-8po7f2/envd-0.3.45/.brew_home/.config/envd/id_rsa_envd if not specified'
complete -c envd -n '__fish_seen_subcommand_from bootstrap' -f -l use-http -d 'Use HTTP instead of HTTPS for the registry'
complete -c envd -n '__fish_seen_subcommand_from bootstrap' -f -l registry -s r -r -d 'Specify the registry to pull the image from'
complete -c envd -n '__fish_seen_subcommand_from bootstrap' -f -l registry-config -r -d 'Path to a JSON file containing registry configuration. Cannot be used with \'registry\' or \'registry-ca-keypair\''
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'run c' -d 'Run the envd environment from the existing image'
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l image -r -d 'image name'
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l name -r -d 'environment name'
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l timeout -r -d 'Timeout of container creation'
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l detach -d 'Detach from the container'
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l path -s p -r -d 'Working directory path to be used as project root'
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l host -r -d 'Assign the host address for the environment SSH access server listening'
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l shm-size -r -d 'Configure the shared memory size (megabyte)'
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l cpus -r -d 'Request CPU resources (number of cores), such as 0.5, 1, 2'
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l memory -r -d 'Request Memory, such as 512M, 2G'
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l gpu -r -d 'Request GPU resources (number of gpus), such as 1, 2'
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l sync -d 'Sync the local directory with the remote container'
complete -c envd -n '__fish_seen_subcommand_from run c' -f -l volume -s v -r -d 'Mount host directory into container'
complete -c envd -n '__fish_seen_subcommand_from completion' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'completion' -d 'Install shell completion scripts for envd'
complete -c envd -n '__fish_seen_subcommand_from completion' -f -l shell -s s -r -d 'Shell type to install completion'
complete -c envd -n '__fish_seen_subcommand_from completion' -f -l no-install -d 'Only output the completion script and don\'t install it'
complete -c envd -n '__fish_seen_subcommand_from completion' -f -l help -s h -d 'show help'
complete -c envd -n '__fish_seen_subcommand_from help h' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_seen_subcommand_from completion' -a 'help h' -d 'Shows a list of commands or help for one command'
complete -c envd -n '__fish_seen_subcommand_from context' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'context' -d 'Manage envd contexts'
complete -c envd -n '__fish_seen_subcommand_from create' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_seen_subcommand_from context' -a 'create' -d 'Create envd context'
complete -c envd -n '__fish_seen_subcommand_from create' -f -l name -r -d 'Name of the context'
complete -c envd -n '__fish_seen_subcommand_from create' -f -l builder -r -d 'Builder to use (docker-container, kube-pod, tcp, unix, moby-worker, nerdctl-container)'
complete -c envd -n '__fish_seen_subcommand_from create' -f -l builder-address -r -d 'Builder address'
complete -c envd -n '__fish_seen_subcommand_from create' -f -l runner -r -d 'Runner to use(docker, envd-server)'
complete -c envd -n '__fish_seen_subcommand_from create' -f -l runner-address -r -d 'Runner address'
complete -c envd -n '__fish_seen_subcommand_from create' -f -l use -d 'Use the context'
complete -c envd -n '__fish_seen_subcommand_from ls' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_seen_subcommand_from context' -a 'ls' -d 'List envd contexts'
complete -c envd -n '__fish_seen_subcommand_from ls' -f -l format -s f -r -d 'Format of output, could be "json" or "table"'
complete -c envd -n '__fish_seen_subcommand_from rm' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_seen_subcommand_from context' -a 'rm' -d 'Remove envd context'
complete -c envd -n '__fish_seen_subcommand_from rm' -f -l name -r -d 'Name of the context'
complete -c envd -n '__fish_seen_subcommand_from use' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_seen_subcommand_from context' -a 'use' -d 'Use the specified envd context'
complete -c envd -n '__fish_seen_subcommand_from use' -f -l name -r -d 'Name of the context'
complete -c envd -n '__fish_seen_subcommand_from build b' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'build b' -d 'Build the envd environment'
complete -c envd -n '__fish_seen_subcommand_from build b' -f -l tag -s t -r -d 'Name and optionally a tag in the \'name:tag\' format'
complete -c envd -n '__fish_seen_subcommand_from build b' -f -l from -s f -r -d 'Function to execute, format `file:func`'
complete -c envd -n '__fish_seen_subcommand_from build b' -f -l use-proxy -s proxy -d 'Use HTTPS_PROXY/HTTP_PROXY/NO_PROXY in the build process'
complete -c envd -n '__fish_seen_subcommand_from build b' -f -l path -s p -r -d 'Path to the directory containing the build.envd'
complete -c envd -n '__fish_seen_subcommand_from build b' -f -l output -s o -r -d 'Output destination (e.g. `type=tar,dest=path,push=true`)'
complete -c envd -n '__fish_seen_subcommand_from build b' -f -l force -d 'Force rebuild the image'
complete -c envd -n '__fish_seen_subcommand_from build b' -f -l export-cache -s ec -r -d 'Export the cache (e.g. `type=registry,ref=<image>`)'
complete -c envd -n '__fish_seen_subcommand_from build b' -f -l import-cache -s ic -r -d 'Import the cache (e.g. `type=registry,ref=<image>`)'
complete -c envd -n '__fish_seen_subcommand_from build b' -f -l platform -r -d 'Specify the target platforms for the build output (for example, "windows/amd64" or "linux/amd64,darwin/arm64").
Build images with same tags could cause image overwriting, platform suffixes will be added to differentiate the images.'
complete -c envd -n '__fish_seen_subcommand_from destroy down d' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'destroy down d' -d 'Destroy the envd environment'
complete -c envd -n '__fish_seen_subcommand_from destroy down d' -f -l path -s p -r -d 'Path to the directory containing the build.envd'
complete -c envd -n '__fish_seen_subcommand_from destroy down d' -f -l name -s n -r -d 'Name of the environment or container ID'
complete -c envd -n '__fish_seen_subcommand_from envs env e' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'envs env e' -d 'Manage envd environments'
complete -c envd -n '__fish_seen_subcommand_from describe d' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_seen_subcommand_from envs env e' -a 'describe d' -d 'Show details about environments, including dependencies and port binding'
complete -c envd -n '__fish_seen_subcommand_from describe d' -f -l env -s e -r -d 'Specify the envd environment to use'
complete -c envd -n '__fish_seen_subcommand_from describe d' -f -l format -s f -r -d 'Format of output, could be "json" or "table"'
complete -c envd -n '__fish_seen_subcommand_from list ls l' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_seen_subcommand_from envs env e' -a 'list ls l' -d 'List envd environments'
complete -c envd -n '__fish_seen_subcommand_from list ls l' -f -l format -s f -r -d 'Format of output, could be "json" or "table"'
complete -c envd -n '__fish_seen_subcommand_from images image' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'images image' -d 'Manage envd images'
complete -c envd -n '__fish_seen_subcommand_from describe d' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_seen_subcommand_from images image' -a 'describe d' -d 'Show details about image, including dependencies'
complete -c envd -n '__fish_seen_subcommand_from describe d' -f -l image -s i -r -d 'Specify the image to use'
complete -c envd -n '__fish_seen_subcommand_from describe d' -f -l format -s f -r -d 'Format of output, could be "json" or "table"'
complete -c envd -n '__fish_seen_subcommand_from list ls l' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_seen_subcommand_from images image' -a 'list ls l' -d 'List envd images'
complete -c envd -n '__fish_seen_subcommand_from list ls l' -f -l format -s f -r -d 'Format of output, could be "json" or "table"'
complete -c envd -n '__fish_seen_subcommand_from prune' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_seen_subcommand_from images image' -a 'prune' -d 'Remove unused images'
complete -c envd -n '__fish_seen_subcommand_from remove r rm' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_seen_subcommand_from images image' -a 'remove r rm' -d 'Remove an envd image'
complete -c envd -n '__fish_seen_subcommand_from remove r rm' -f -l image -s i -r -d 'Specify the image name to be removed'
complete -c envd -n '__fish_seen_subcommand_from remove r rm' -f -l tag -s t -r -d 'Remove the image with a specific tag'
complete -c envd -n '__fish_seen_subcommand_from init i' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'init i' -d 'Automatically generate the build.envd'
complete -c envd -n '__fish_seen_subcommand_from init i' -f -l lang -s l -r -d 'language usage. Support Python, R, Julia'
complete -c envd -n '__fish_seen_subcommand_from init i' -f -l force -s f -d 'overwrite the build.envd if existed'
complete -c envd -n '__fish_seen_subcommand_from init i' -f -l path -s p -r -d 'Path to the directory containing the build.envd'
complete -c envd -n '__fish_seen_subcommand_from login' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'login' -d 'Login to the envd server defined in the current context'
complete -c envd -n '__fish_seen_subcommand_from login' -f -l username -s u -r -d 'the login name in envd server'
complete -c envd -n '__fish_seen_subcommand_from login' -f -l password -s p -r -d 'password'
complete -c envd -n '__fish_seen_subcommand_from pause p' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'pause p' -d 'Pause the envd environment'
complete -c envd -n '__fish_seen_subcommand_from pause p' -f -l env -s e -r -d 'Environment name'
complete -c envd -n '__fish_seen_subcommand_from prune' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'prune' -d 'Clean up the build cache'
complete -c envd -n '__fish_seen_subcommand_from prune' -f -l keep-duration -r -d 'Keep data newer than this limit'
complete -c envd -n '__fish_seen_subcommand_from prune' -f -l keep-storage -r -d 'Keep data below this limit (in MB)'
complete -c envd -n '__fish_seen_subcommand_from prune' -f -l all -d 'Include internal caches (oh-my-zsh, vscode extensions and other envd caches)'
complete -c envd -n '__fish_seen_subcommand_from prune' -f -l verbose -d 'Verbose output'
complete -c envd -n '__fish_seen_subcommand_from exec' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'exec' -d 'Spawns a command installed into the environment.'
complete -c envd -n '__fish_seen_subcommand_from exec' -f -l name -s n -r -d 'Name of the environment'
complete -c envd -n '__fish_seen_subcommand_from exec' -f -l command -s c -r -d 'Command defined in build.envd to execute'
complete -c envd -n '__fish_seen_subcommand_from exec' -f -l from -s f -r -d 'Function to execute, format `file:func`'
complete -c envd -n '__fish_seen_subcommand_from exec' -f -l path -s p -r -d 'Path to the directory containing the build.envd'
complete -c envd -n '__fish_seen_subcommand_from exec' -f -l raw -s r -r -d 'Raw command to execute'
complete -c envd -n '__fish_seen_subcommand_from resume r' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'resume r' -d 'Resume the envd environment'
complete -c envd -n '__fish_seen_subcommand_from resume r' -f -l env -s e -r -d 'Environment name'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'up u' -d 'Build and run the envd environment'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l tag -s t -r -d 'Name and optionally a tag in the \'name:tag\' format'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l name -r -d 'environment name'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l path -s p -r -d 'Path to the directory containing the build.envd'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l volume -s v -r -d 'Mount host directory into container'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l from -s f -r -d 'Function to execute, format `file:func`'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l use-proxy -s proxy -d 'Use HTTPS_PROXY/HTTP_PROXY/NO_PROXY in the build process'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l timeout -r -d 'Timeout of container creation'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l shm-size -r -d 'Configure the shared memory size (megabyte)'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l cpus -r -d 'Request CPU resources (number of cores), such as 0.5, 1, 2'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l cpu-set -r -d 'Limit the specific CPUs or cores the environment can use, such as `0-3`, `1,3`'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l memory -r -d 'Request Memory, such as 512Mb, 2Gb'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l detach -d 'Detach from the container'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l no-gpu -d 'Launch the CPU container even if it\'s a GPU image'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l gpus -r -d 'Number of GPUs used in this environment, this will override the `config.gpu()`'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l force -d 'Force rebuild and run the container although the previous container is running'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l host -r -d 'Assign the host address for the environment SSH access server listening'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l export-cache -s ec -r -d 'Export the cache (e.g. `type=registry,ref=<image>`)'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l import-cache -s ic -r -d 'Import the cache (e.g. `type=registry,ref=<image>`)'
complete -c envd -n '__fish_seen_subcommand_from up u' -f -l platform -r -d 'Specify the target platform for the build output, (for example, windows/amd64, linux/amd64, or darwin/arm64)'
complete -c envd -n '__fish_seen_subcommand_from debug b' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'debug b' -d 'Debug commands'
complete -c envd -n '__fish_seen_subcommand_from llb b' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_seen_subcommand_from debug b' -a 'llb b' -d 'dump buildkit LLB in human-readable format.'
complete -c envd -n '__fish_seen_subcommand_from llb b' -f -l dot -d 'Output dot format'
complete -c envd -n '__fish_seen_subcommand_from llb b' -f -l path -s p -r -d 'Path to the directory containing the build.envd'
complete -c envd -n '__fish_seen_subcommand_from llb b' -f -l from -s f -r -d 'Function to execute, format `file:func`'
complete -c envd -n '__fish_seen_subcommand_from version v' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'version v' -d 'Print envd version information'
complete -c envd -n '__fish_seen_subcommand_from version v' -f -l short -s s -d 'Only print the version number'
complete -c envd -n '__fish_seen_subcommand_from version v' -f -l detail -s d -d 'Print details about the envd environment'
complete -c envd -n '__fish_seen_subcommand_from version v' -f -l format -s f -r -d 'Format of output, could be "json" or "table"'
complete -c envd -n '__fish_seen_subcommand_from top' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'top' -d 'Show statistics about the containers managed by the environment.'
complete -c envd -n '__fish_seen_subcommand_from reference' -f -l help -s h -d 'show help'
complete -r -c envd -n '__fish_envd_no_subcommand' -a 'reference' -d 'Print envd reference documentation'
complete -c envd -n '__fish_seen_subcommand_from reference' -f -l output -r -d 'Output file, if not specified, print to stderr'

